# Controls thrown shield's AI behavior.

# Runs spin animation.
function code:item/cap_shield/throw/spin_animation


# Moves forward.
teleport @s[tag=!Return] ^ ^ ^2


# If shield hits an entity, deals damage and returns to player. Has a chance to ricochet and bounce between multiple enemies before returning to player.
execute positioned ~-0.5 ~0.5 ~-0.5 if entity @e[dx=0,dy=0,dz=0,type=!#code:cap_no_target,scores={HitCooldown=0}] run function code:item/cap_shield/throw/shield_hit
execute as @s[tag=Ricochet] at @s run teleport @s ~ ~ ~ facing entity @n[distance=..21,type=#code:ricochet_valid,scores={HitCooldown=0}]


# When shield hits a surface, or after a certain amount of time, returns to player.
execute positioned ~ ~1 ~ unless block ~ ~ ~ #ac_lib:non_solid run tag @s add Return
execute positioned ~ ~1 ~ unless block ^ ^ ^1 #ac_lib:non_solid run tag @s add Return

scoreboard players add @s Generic2 1
tag @s[tag=!Ricochet,scores={Generic2=40..}] add Return

execute as @s[tag=Return] run function code:item/cap_shield/throw/return_1


# If a thrown Mjolnir is detected nearby, an energy explosion is created.
execute as @s[tag=!Collided] if entity @e[distance=..2,type=minecraft:trident,tag=Mjolnir] run function code:item/cap_shield/throw/mjolnir_collide