###############
### GENERAL ###
###############

# Detecting hotbar slot change.
function ac_lib:mechanic/slot_check/main

# Right click detection (wfoas).
execute if score @s RightClick matches 1.. at @s run function ac_lib:mechanic/right_click/main



###############
### MJOLNIR ###
###############

### Thunder Jump ###
execute at @s[tag=CanFly] run function code:item/mjolnir/ability/thunder_jump/flying

# Pressing sneak will cancel the jump and make player slam down.
execute at @s[tag=Slamming] run function code:item/mjolnir/ability/thunder_jump/slamming

# Handles earning the advancement "Thunder Hop".
execute as @s[scores={ThunderHopCheck=1..}] at @s run function code:item/mjolnir/ability/thunder_jump/thunder_hop/thunder_hop_check



################################
### CAPTAIN AMERICA'S SHIELD ###
################################

# Replacing shield model with warped fungus model when in main hand.
execute if predicate code:equip_item/mainhand/cap_shield/cap_shield_shield run item replace entity @s weapon.mainhand from block 1 -64 1 container.1

# Replacing warped fungus model with shield model when in off hand.
execute if predicate code:equip_item/offhand/cap_shield/cap_shield_wfoas run item replace entity @s weapon.offhand from block 1 -64 1 container.0

# Returns thrown shield under various odd circumstances.
execute as @s[tag=ThrewShield] at @s run function code:item/cap_shield/throw/odd_return_check

# Advancement for killing 10 enemies in 10 seconds ("I can do this all day").
execute if score @s CapKillTimer matches 1.. run function code:advancement/cap_shield/cap_kills/countdown


### ENERGY DEFLECT ###

execute at @s[tag=DeflectGCheck] run function code:item/cap_shield/energy_deflect/guardian/main


function code:reset/player