# Determines if this raycast needs a random spread applied.
execute as @s[tag=RSpread] store result score GameRef.RSpreadX TempValue1 run random value -5..5
execute as @s[tag=RSpread] store result score GameRef.RSpreadY TempValue1 run random value -5..5
execute as @s[tag=RSpread] run function ac_lib:effect/raycast/general/get_rotation/x_main

# Otherwise runs the raycast as normal.
execute as @s[tag=!RSpread] anchored eyes positioned ^ ^ ^0.1 run function ac_lib:effect/raycast/general/do

# Performs additional raycasts if needed.
scoreboard players remove GameRef.RNumber TempValue1 1
execute if score GameRef.RNumber TempValue1 matches 1.. run function ac_lib:weapons/basic_guns/raycast_prep
execute if score GameRef.RNumber TempValue1 matches 1.. run scoreboard players operation GameRef TempValue1 = GameRef.RaycastMem TempValue1
execute if score GameRef.RNumber TempValue1 matches 1.. run function ac_lib:effect/raycast/general/prep


# Resets everything.
scoreboard players reset GameRef.RayDist TempValue1
scoreboard players reset GameRef.RDX TempValue1
scoreboard players reset GameRef.RPierceCount TempValue1
scoreboard players reset GameRef.RSpreadX TempValue1
scoreboard players reset GameRef.RSpreadY TempValue1
scoreboard players reset GameRef.RNumber TempValue1
tag @s remove Raycast
tag @s remove RAOE
tag @s remove RFindPlayer
tag @s remove RGetPos
tag @s remove RParticles
tag @s remove RSpread

tag @e[type=#ac_lib:mobs_p,tag=RemoveThis,distance=..200] remove This
tag @e[type=#ac_lib:mobs_p,tag=RemoveThis,distance=..200] remove RemoveThis