# Controls behavior of player while they're in flight. Different conditions will trigger an explosion.

# Resistance to negate taking damage when landing.
effect give @s minecraft:resistance 1 10 true


# If player sneaks while mid-Thunder Jump, they can cancel the jump and slam to the ground really fast.
tag @s add DoSlam
execute on vehicle on passengers run tag @s[type=minecraft:player] remove DoSlam
execute as @s[tag=DoSlam] run function code:item/mjolnir/ability/thunder_jump/slam_prep


# Making contact with the ground creates an explosion.
scoreboard players add @s TJDelay 1
execute as @s[tag=!Slamming,scores={TJDelay=4..}] unless block ~ ~-0.1 ~ #ac_lib:non_solid run function code:item/mjolnir/ability/thunder_jump/land


# By hitting a mob directly, player can explode off that mob into the air, then throw the trident again at another mob. Then another, and another. It's pretty fun, actually.
execute as @s[tag=TJChainJump] run function code:item/mjolnir/ability/thunder_jump/land_chain