# Hub function for the animation that takes place to summon Mjolnir into the world. Different effects get played at different intervals.

scoreboard players add @s AnimationTime 1



# Move first ingredient into place, begin rotation. 
execute as @s[scores={AnimationTime=60..80}] run function code:item/mjolnir/craft/animation/a1


# Move second ingredient into place, begin rotation.
execute as @s[scores={AnimationTime=120..140}] run function code:item/mjolnir/craft/animation/a2


# Move third ingredient into place, begin rotation.
execute as @s[scores={AnimationTime=180..200}] run function code:item/mjolnir/craft/animation/a3


# Three particle burst before beginning.
execute as @s[scores={AnimationTime=240..280}] run function code:item/mjolnir/craft/animation/a4


# Constant "swirl" of particles.
execute as @s[scores={AnimationTime=240..}] run function code:item/mjolnir/craft/animation/a5


# Increasing pitch over time.
execute as @s[scores={AnimationTime=340..620}] run function code:item/mjolnir/craft/animation/a6



# Rotation. Like a sweet rotisserie. Mmmmm
teleport @s ~ ~ ~ ~10 ~


# First stage rotation.
execute as @s[scores={AnimationTime=240..340}] run function code:item/mjolnir/craft/animation/a7


# Second stage rotation.
execute as @s[scores={AnimationTime=340..380}] run function code:item/mjolnir/craft/animation/a8


# Third stage rotation.
execute as @s[scores={AnimationTime=380..420}] run function code:item/mjolnir/craft/animation/a9


#Fourth stage rotation.
execute as @s[scores={AnimationTime=420..460}] run function code:item/mjolnir/craft/animation/a10


#Fifth stage rotation.
execute as @s[scores={AnimationTime=460..500}] run function code:item/mjolnir/craft/animation/a11


#Sixth stage rotation.
execute as @s[scores={AnimationTime=500..540}] run function code:item/mjolnir/craft/animation/a12


#Seventh stage rotation.
execute as @s[scores={AnimationTime=540..580}] run function code:item/mjolnir/craft/animation/a13


#Eighth stage rotation.
execute as @s[scores={AnimationTime=580..}] run function code:item/mjolnir/craft/animation/a14



# Summons lightning at different intervals.
execute as @s[scores={AnimationTime=660..805}] run function code:item/mjolnir/craft/animation/a15


#Bunch of them in succession.
execute as @s[scores={AnimationTime=805..865}] run summon minecraft:lightning_bolt ~ ~ ~



# Big finish.
execute as @s[scores={AnimationTime=885}] run function code:item/mjolnir/craft/animation/end